org.jgroups.protocols

## Class STOMP

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.STOMP

- All Implemented Interfaces:
    java.lang.Runnable

      public class STOMP
      extends Protocol
      implements java.lang.Runnable

  Protocol which provides STOMP (http://stomp.codehaus.org/) support. Very simple implementation, with a one-thread-per-connection model. Use for a few hundred clients max.

  The intended use for this protocol is pub-sub with clients which handle text messages, e.g. stock updates, SMS messages to mobile clients, SNMP traps etc.

  Note that the full STOMP protocol has not yet been implemented, e.g. transactions are not supported. todo: use a thread pool to handle incoming frames and to send messages to clients

  todo: add PING to test health of client connections

  Since:
    2.11
  Author:
    Bela Ban

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `STOMP.ClientVerb`
    `class` | `STOMP.Connection` Class which handles a connection to a client
    `static class` | `STOMP.Frame`
    `static class` | `STOMP.ServerVerb`
    `static class` | `STOMP.StompHeader`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.Thread` | `acceptor`
    `protected java.net.InetAddress` | `bind_addr`
    `protected java.util.List<STOMP.Connection>` | `connections`
    `protected java.lang.String` | `endpoint`
    `protected java.lang.String` | `endpoint_addr`
    `protected java.util.Map<Address,java.lang.String>` | `endpoints`
    `protected boolean` | `exact_destination_match`
    `protected boolean` | `forward_non_client_generated_msgs`
    `protected Address` | `local_addr`
    `static byte` | `NULL_BYTE`
    `protected int` | `port`
    `protected boolean` | `send_info`
    `protected java.net.ServerSocket` | `srv_sock`
    `protected java.util.concurrent.ConcurrentMap<java.lang.String,java.util.Set<STOMP.Connection>>` | `subscriptions`
    `protected View` | `view`

    - ### Fields inherited from class org.jgroups.stack.Protocol

      `down_prot, ergonomics, id, log, name, stack, stats, up_prot`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `STOMP()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `broadcastEndpoint()`
    `java.lang.Object` | `down(Event evt)` An event is to be sent down the stack.
    `protected java.lang.String` | `getAllEndpoints()`
    `java.lang.String` | `getEndpoints()`
    `int` | `getNumConnections()`
    `int` | `getNumSubscriptions()`
    `java.lang.String` | `getSubscriptions()`
    `protected void` | `handleView(View view)`
    `static STOMP.Frame` | `readFrame(java.io.DataInputStream in)`
    `void` | `run()`
    `void` | `start()` This method is called on a `Channel.connect(String)`.
    `void` | `stop()` This method is called on a `Channel.disconnect()`.
    `java.lang.Object` | `up(Event evt)` An event was received from the layer below.

    - ### Methods inherited from class org.jgroups.stack.Protocol

      `destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, init, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, resetStats, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### bind_addr

          protected java.net.InetAddress bind_addr

    - #### endpoint_addr

          protected java.lang.String endpoint_addr

    - #### port

          protected int port

    - #### exact_destination_match

          protected boolean exact_destination_match

    - #### send_info

          protected boolean send_info

    - #### forward_non_client_generated_msgs

          protected boolean forward_non_client_generated_msgs

    - #### local_addr

          protected Address local_addr

    - #### srv_sock

          protected java.net.ServerSocket srv_sock

    - #### endpoint

          protected java.lang.String endpoint

    - #### acceptor

          protected java.lang.Thread acceptor

    - #### connections

          protected final java.util.List<STOMP.Connection> connections

    - #### endpoints

          protected final java.util.Map<Address,java.lang.String> endpoints

    - #### view

          protected View view

    - #### subscriptions

          protected final java.util.concurrent.ConcurrentMap<java.lang.String,java.util.Set<STOMP.Connection>> subscriptions

    - #### NULL_BYTE

          public static final byte NULL_BYTE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### STOMP

          public STOMP()

  - ### Method Detail

    - #### getNumConnections

          public int getNumConnections()

    - #### getNumSubscriptions

          public int getNumSubscriptions()

    - #### getSubscriptions

          public java.lang.String getSubscriptions()

    - #### getEndpoints

          public java.lang.String getEndpoints()

    - #### start

          public void start()
                     throws java.lang.Exception

      Description copied from class: `Protocol`
      This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.
      Overrides:
        `start` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

    - #### stop

          public void stop()

      Description copied from class: `Protocol`
      This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed
      Overrides:
        `stop` in class `Protocol`

    - #### run

          public void run()

      Specified by:
        `run` in interface `java.lang.Runnable`

    - #### down

          public java.lang.Object down(Event evt)

      Description copied from class: `Protocol`
      An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.
      Overrides:
        `down` in class `Protocol`

    - #### up

          public java.lang.Object up(Event evt)

      Description copied from class: `Protocol`
      An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.
      Overrides:
        `up` in class `Protocol`

    - #### readFrame

          public static STOMP.Frame readFrame(java.io.DataInputStream in)
                                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### handleView

          protected void handleView(View view)

    - #### getAllEndpoints

          protected java.lang.String getAllEndpoints()

    - #### broadcastEndpoint

          protected void broadcastEndpoint()

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.